/* ORIGINAL CODE */

function checkChange(checknames, varname)	{
	var res = 0;
	for (var a=1; a<=5; a++)	{
		if (document.editform[checknames+"["+a+"]"].checked)	{
			res|=Math.pow(2,a-1);
		}
	}
	document.editform[varname].value = res | (checknames=="check[perms_user]"?1:0) ;
	setCheck (checknames,varname);
}

function setCheck(checknames, varname)	{
	if (document.editform[varname])	{
		var res = document.editform[varname].value;
		for (var a=1; a<=5; a++)	{
			document.editform[checknames+"["+a+"]"].checked = (res & Math.pow(2,a-1));
		}
	}
}

function jumpToUrl(URL)	{
	window.location.href = URL;
}


/* AJAX RELATED */
// Set the permissions by executing an ajax call
function setPermissions(uri, page, bits, mode, who, permissions) {
	new Ajax.Request(uri,
	{
		method:'post',
		parameters: {page: page, permissions: permissions, mode: mode, who: who, bits: bits},
		onSuccess: function(transport) {
			updatePermissionStatus(page + "_" + who, transport.responseText);
		},
		onFailure: function() { alert('An error occured. (1)') }
	});
}

// Update the HTML view of the permissions
function updatePermissionStatus(elementID, newPermissionState) {
	$(elementID).innerHTML = newPermissionState;
}

// Load the selector by executing an ajax call
function showChangeOwnerSelector(uri, page, owner_uid, elementID, username) {
	new Ajax.Request(uri,
	{
		method:'post',
		parameters: {page: page, action: 'show_change_owner_selector', owner_uid: owner_uid, username: username},
		onSuccess: function(transport) {
			$(elementID).innerHTML = transport.responseText;
		},
		onFailure: function() { alert('An error occured. (2)') }
	});
}

// Set the new owner by executing an ajax call
function changeOwner(uri, page, owner_uid, elementID) {
	new Ajax.Request(uri,
	{
		method:'post',
		parameters: {page: page, action: 'change_owner', owner_uid: owner_uid, owner_data: $('new_page_owner').serialize(true)},
		onSuccess: function(transport) {
			$(elementID).innerHTML = transport.responseText;
		},
		onFailure: function() { alert('An error occured. (3)') }
	});
}

// Update the HTML view and show the original owner
function restoreOwner(uri, page, owner_uid, username, elementID) {
	var innerUserHTML = "<span id=\"o_" + page + "_" + owner_uid + "\"><a class=\"ug_selector\" onClick=\"showChangeOwnerSelector('"+uri+"', '"+page+"', '"+owner_uid+"', 'o_"+page+"_"+owner_uid+"', '"+username+"');\">"+username+"</a></span>";
	$(elementID).innerHTML = innerUserHTML;
}

// Load the selector by executing an ajax call
function showChangeGroupSelector(uri, page, group_uid, elementID, groupname) {
	new Ajax.Request(uri,
	{
		method:'post',
		parameters: {page: page, action: 'show_change_group_selector', group_uid: group_uid, groupname: groupname},
		onSuccess: function(transport) {
			$(elementID).innerHTML = transport.responseText;
		},
		onFailure: function() { alert('An error occured. (4)') }
	});
}

// Set the new group by executing an ajax call
function changeGroup(uri, page, group_uid, elementID) {
	new Ajax.Request(uri,
	{
		method:'post',
		parameters: {page: page, action: 'change_group', group_uid: group_uid, group_data: $('new_page_group').serialize(true)},
		onSuccess: function(transport) {
			$(elementID).innerHTML = transport.responseText;
		},
		onFailure: function() { alert('An error occured. (5)') }
	});
}

// Update the HTML view and show the original group
function restoreGroup(uri, page, group_uid, groupname, elementID) {
	var innerGroupHTML = "<span id=\"g_" + page + "_" + group_uid + "\"><a class=\"ug_selector\" onClick=\"showChangeGroupSelector('"+uri+"', '"+page+"', '"+group_uid+"', 'g_"+page+"_"+group_uid+"', '"+groupname+"');\">"+groupname+"</a></span>";
	$(elementID).innerHTML = innerGroupHTML;
}